.486
.model flat, stdcall
option casemap: none

BMPBTN	equ	1
; API functions
; ************************************
include	\masm32\include\windows.inc
include	\masm32\include\kernel32.inc
include	\masm32\include\user32.inc
include	\masm32\include\gdi32.inc
include	\masm32\include\comctl32.inc
include	\masm32\include\masm32.inc
include	\masm32\include\ole32.inc
include \masm32\include\oleaut32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\ole32.lib
includelib \masm32\lib\oleaut32.lib
includelib \masm32\lib\masm32.lib

include	   \masm32\macros\macros.asm

include lib\BmpFrom.inc
include lib\bmpbutn.asm


; Prototype 
; ************************************
DialogProc    PROTO : HWND, : UINT, : WPARAM, : LPARAM
TranspWindow  PROTO : DWORD,: DWORD
.const
; Resource ids
; ************************************
IDD_DLG1  	       equ 101
IDI_ICON           equ 200
IDI_EXIT	       equ 300
FRAME              equ 500
TRANSPARENT_VALUE  equ 210
; Required data

.data

.data?
hInstance HINSTANCE ?
hIcon     HICON     ?
hExit		dd	?
rct RECT       <?>
hBitmap 	 dd ?
hBrushD      dd ?
.code

start:


invoke GetModuleHandle, NULL
mov hInstance, eax

invoke LoadIcon, eax, IDI_ICON 
mov hIcon, eax
invoke InitCommonControls
invoke DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR DialogProc, SW_SHOWDEFAULT
invoke ExitProcess, 0


; Dialog procedure
; ************************************
DialogProc proc hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM

local	ps:PAINTSTRUCT

Mov	eax, uMsg
.if eax == WM_INITDIALOG
;make dialog transparent
invoke TranspWindow,hWnd,TRANSPARENT_VALUE
 ;  Create rounded corners
invoke GetClientRect,hWnd,offset rct
invoke CreateRoundRectRgn,0,0,rct.right,rct.bottom,14,14
invoke SetWindowRgn,hWnd,eax,TRUE

invoke ImageButton,hWnd,240,1,703,701,702,IDI_EXIT		;custom image button (JPG,BMP,PNG) Left,Up,DownID,UpID,OverID
mov hExit,eax
invoke 	LoadBitmap, hInstance, FRAME
Mov 	hBitmap, Eax
invoke CreatePatternBrush,eax
mov hBrushD,eax
xor eax,eax
inc eax		
.elseif eax == WM_CTLCOLORDLG
mov eax,hBrushD
Ret		
.elseif eax == WM_LBUTTONDOWN
invoke SendMessage, hWnd, WM_NCLBUTTONDOWN,HTCAPTION, 0

.elseif  uMsg == WM_COMMAND
.if  wParam ==IDI_EXIT
invoke SendMessage,hWnd,WM_CLOSE,0,0

    .endif
 .elseif  uMsg == WM_CLOSE 

invoke EndDialog, hWnd, 0
 .endif
 
    xor eax,eax
  ret
DialogProc endp
; TranspWindow procedure
; ************************************
TranspWindow proc _dialoghandle:dword,_value:dword

pushad
invoke GetModuleHandle,chr$("user32.dll")
invoke GetProcAddress,eax,chr$("SetLayeredWindowAttributes")
.if eax!=0

mov edi,eax
invoke GetWindowLong,_dialoghandle,GWL_EXSTYLE	;get EXSTYLE

.if _value==255
xor eax,WS_EX_LAYERED	;remove WS_EX_LAYERED
.else
or eax,WS_EX_LAYERED	;eax = oldstlye + new style(WS_EX_LAYERED)
.endif
invoke SetWindowLong,_dialoghandle,GWL_EXSTYLE,eax

.if _value<255
push LWA_ALPHA
push _value		    ;set level of transparency
push 0			    ;transparent color
push _dialoghandle	;window handle
call edi			;call SetLayeredWindowAttributes
.endif	
.endif

popad
ret
TranspWindow endp
end start